Package org.apache.sysds.runtime.instructions.fed

## Class QuantilePickFEDInstruction

- java.lang.Object
- - org.apache.sysds.runtime.instructions.Instruction
  - - org.apache.sysds.runtime.instructions.fed.FEDInstruction
    - - org.apache.sysds.runtime.instructions.fed.ComputationFEDInstruction
      - - org.apache.sysds.runtime.instructions.fed.BinaryFEDInstruction
        - - org.apache.sysds.runtime.instructions.fed.QuantilePickFEDInstruction

- All Implemented Interfaces:
    `LineageTraceable`

      public class QuantilePickFEDInstruction
      extends BinaryFEDInstruction

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `QuantilePickFEDInstruction.CreateMatrixFromFrame` |
    `static class` | `QuantilePickFEDInstruction.GetHistogram` |
    `static class` | `QuantilePickFEDInstruction.GetValuesInRange` |
    `static class` | `QuantilePickFEDInstruction.GetValuesInRanges` |
    `static class` | `QuantilePickFEDInstruction.MinMax` |

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.fed.FEDInstruction

      `FEDInstruction.FederatedOutput, FEDInstruction.FEDType`

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.Instruction

      `Instruction.IType`

  - ### Field Summary

    - ### Fields inherited from class org.apache.sysds.runtime.instructions.fed.ComputationFEDInstruction

      `input1, input2, input3, output`

    - ### Fields inherited from class org.apache.sysds.runtime.instructions.Instruction

      `DATATYPE_PREFIX, FEDERATED_INST_PREFIX, GPU_INST_PREFIX, INSTRUCTION_DELIM, LITERAL_PREFIX, OPERAND_DELIM, SP_INST_PREFIX, VALUETYPE_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `QuantilePickFEDInstruction​(Operator op, CPOperand in, CPOperand out, PickByCount.OperationTypes type, boolean inmem, String opcode, String istr)` |
    `QuantilePickFEDInstruction​(Operator op, CPOperand in, CPOperand in2, CPOperand out, PickByCount.OperationTypes type, boolean inmem, String opcode, String istr)` |
    `QuantilePickFEDInstruction​(Operator op, CPOperand in, CPOperand in2, CPOperand out, PickByCount.OperationTypes type, boolean inmem, String opcode, String istr, FEDInstruction.FederatedOutput fedOut)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<T> T` | `createHistogram​(CacheableData<?> in, int vectorLength, double globalMin, double globalMax, int numBuckets, int quantileIndex, boolean average)` |
    `<T> MatrixBlock` | `getEquiHeightBins​(ExecutionContext ec, int colID, double[] quantiles)` |
    `static QuantilePickFEDInstruction` | `parseInstruction​(String str)` |
    `static QuantilePickFEDInstruction` | `parseInstruction​(Instruction inst)` |
    `void` | `processColumnQPick​(ExecutionContext ec)` |
    `void` | `processInstruction​(ExecutionContext ec)` | This method should be used to execute the instruction.
    `<T> void` | `processRowQPick​(ExecutionContext ec)` |

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.fed.ComputationFEDInstruction

      `getLineageItem, getOutputVariableName`

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.fed.FEDInstruction

      `getFEDInstructionType, getTID, getType, preprocessInstruction, setTID`

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.Instruction

      `getBeginColumn, getBeginLine, getEndColumn, getEndLine, getExtendedOpcode, getFilename, getGraphString, getInstID, getInstructionString, getLineNum, getOpcode, getOperator, getPrivacyConstraint, postprocessInstruction, printMe, requiresLabelUpdate, setInstID, setLocation, setLocation, setLocation, setLocation, setPrivacyConstraint, setPrivacyConstraint, toString, updateInstructionThreadID`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.sysds.runtime.lineage.LineageTraceable

      `getLineageItems, hasSingleLineage`

- - ### Constructor Detail

    - #### QuantilePickFEDInstruction

          public QuantilePickFEDInstruction​(Operator op,
                                            CPOperand in,
                                            CPOperand out,
                                            PickByCount.OperationTypes type,
                                            boolean inmem,
                                            String opcode,
                                            String istr)

    - #### QuantilePickFEDInstruction

          public QuantilePickFEDInstruction​(Operator op,
                                            CPOperand in,
                                            CPOperand in2,
                                            CPOperand out,
                                            PickByCount.OperationTypes type,
                                            boolean inmem,
                                            String opcode,
                                            String istr,
                                            FEDInstruction.FederatedOutput fedOut)

    - #### QuantilePickFEDInstruction

          public QuantilePickFEDInstruction​(Operator op,
                                            CPOperand in,
                                            CPOperand in2,
                                            CPOperand out,
                                            PickByCount.OperationTypes type,
                                            boolean inmem,
                                            String opcode,
                                            String istr)

  - ### Method Detail

    - #### parseInstruction

          public static QuantilePickFEDInstruction parseInstruction​(Instruction inst)

    - #### parseInstruction

          public static QuantilePickFEDInstruction parseInstruction​(String str)

    - #### processInstruction

          public void processInstruction​(ExecutionContext ec)

      Description copied from class: `Instruction`
      This method should be used to execute the instruction.
      Specified by:
        `processInstruction` in class `Instruction`
      Parameters:
        `ec` - execution context

    - #### getEquiHeightBins

          public <T> MatrixBlock getEquiHeightBins​(ExecutionContext ec,
                                                   int colID,
                                                   double[] quantiles)

    - #### processRowQPick

          public <T> void processRowQPick​(ExecutionContext ec)

    - #### createHistogram

          public <T> T createHistogram​(CacheableData<?> in,
                                       int vectorLength,
                                       double globalMin,
                                       double globalMax,
                                       int numBuckets,
                                       int quantileIndex,
                                       boolean average)

    - #### processColumnQPick

          public void processColumnQPick​(ExecutionContext ec)